-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.Utils.Class";
import "Tonic.UI.CheckBox";
import "Tonic.UI.ComboBox";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";
import "Tonic.TonicBars.Bars.Quickslots.TypeHelper";

buttonWidth = 90;
selectionWidth = 160;
selectionHeight = 20;
insideBoxXOffset = selectionWidth + 5;
insideBoxYOffset = startFromTop + 200;

EasyBarMenu = class( Tonic.UI.AutoListBox );

function EasyBarMenu:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );
	
	self.utils = Tonic.UI.MenuUtils();

	self.utils:AddCategoryBox(self, LOCALESTRINGS.EasyBarMenu["Create Bars Quickly"]);
	--self.upperBar = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
	self.utils:AddLabelBox( self, LOCALESTRINGS.EasyBarMenu["This menu is used to create complicated bars, very easily. Often getting everything setup on your bar takes a lot of time. Hopefully this helps you get where you want to go easier."], selectionWidth + 250, selectionHeight + 20 );
	
	self.utils:AddLabelBox( self, "", 0, 15 );
	self.utils:AddCategoryBox(self, LOCALESTRINGS.EasyBarMenu["Class Based Bars"]);

	self.buttonList = { };
	self.removeList = { };
	local processingID = 0;
	local easyBars = configHelper:GetEasyBars();
	if ( easyBars ~= nil ) then
		for key, value in pairs (configHelper:GetEasyBars()) do
			processingID = processingID + 1;
			for key2, value2 in pairs (configHelper:GetEasyBars()) do
				if ( value2.sortindex == processingID ) then
					local bar = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal, 0, 25, 0, 0 );
					self.buttonList[key2] = Turbine.UI.Lotro.Button();
					self.buttonList[key2]:SetParent( bar );
					self.buttonList[key2]:SetText( LOCALESTRINGS.ClassBars[key2] );
					self.buttonList[key2]:SetSize( buttonWidth + 25, selectionHeight + 50 );
					self.buttonList[key2]:SetEnabled( true );
					self.buttonList[key2].MouseClick = function( sender, args )
						value2.callback( self, true );
						configHelper:Save();
						maitre_d:LoadQuickslots();
						maitre_d:RefreshBars();
						inventoryManager:NotifyClients();
						self:DisplaySettings();
					end
					bar:AddItem( self.buttonList[key2] );
			
					self.removeList[key2] = Turbine.UI.Lotro.Button();
					self.removeList[key2]:SetParent( bar );
					self.removeList[key2]:SetText( LOCALESTRINGS.EasyBarMenu["Remove"] );
					self.removeList[key2]:SetSize( buttonWidth + 25, selectionHeight );
					self.removeList[key2]:SetEnabled( false );
					self.removeList[key2].MouseClick = function( sender, args )
						local foundbar = nil;
						for key3, value3 in pairs ( theSettingsManager:GetBars() ) do
							if ( value3.barName == value2.barname ) then
								foundbar = key3;
							end
						end
						if ( foundbar ~= nil ) then
							maitre_d:Remove( foundbar );
						end
						self:DisplaySettings();
					end	
					bar:AddItem( self.removeList[key2] );
					self:AddItem( bar );
				end
			end
		end
	end
end

function EasyBarMenu:AddSettings()
end

function EasyBarMenu:DisplaySettings( showQuickslots )
	for key, value in pairs (self.buttonList) do
		value:SetEnabled( true );
		self.removeList[key]:SetEnabled( false );
	end
	local easyBars = configHelper:GetEasyBars();
	if ( easyBars ~= nil ) then
		for key, value in pairs ( easyBars ) do
			for key2, value2 in pairs (theSettingsManager:GetBars()) do
				if ( value.barname == value2.barName and self.buttonList ~= nil and self.buttonList[key] ~= nil ) then
					self.buttonList[key]:SetEnabled( false );
					self.removeList[key]:SetEnabled( true );
				end
			end
		end
	end
end

function EasyBarMenu:AddCommandsBar()
end

function EasyBarMenu:GetSelection()
	return true;
end

function EasyBarMenu:ClearSelection()
end

function EasyBarMenu:RefreshComboBox( barid )
end